<?php

/***************************************************************************
 *
 *   title:               Mapa Google
 *   file:                admin/admin_googlemap.php
 *   authors:             qbs
 *                        paszczak
 *   web:                 beatsfactory.pl/qbs/
 *                        paszczak.thecamels.org
 *
 *   --- Based on --------------------
 *
 *   MOD                  : Atlas MOD
 *   file                 : admin/admin_atlas_mod.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('MODULE_ID', 12345);
define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['General']['GoogleMap'] = $file;
	return;
}

$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

$sql = "SELECT * FROM " . CONFIG_TABLE;
if( !$result = $db->sql_query($sql) )
{
	message_die(CRITICAL_ERROR, "Could not query config information", "", __LINE__, __FILE__, $sql);
}
while( $row = $db->sql_fetchrow($result) )
{
	$board_config[$row['config_name']] = $row['config_value'];
}

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_googlemap.' . $phpEx);


//
// Is this the installation?
// If yes, we need to set up the databas
//

if (isset($HTTP_POST_VARS['submit']) && isset($HTTP_POST_VARS['install_key']) && isset($HTTP_POST_VARS['install_key_admin']) && !isset($board_config['googlemap_google_api_key']) && !isset($board_config['googlemap_google_api_key_admin']))
{
	if (!empty($HTTP_POST_VARS['install_key']) && !empty($HTTP_POST_VARS['install_key_admin']))
	{

		$message = $lang['GMap_mod_installed'] . "<br /><br />" . sprintf($lang['Click_return_googlemap_config'], "<a href=\"" . append_sid("admin_googlemap.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	else
	{
		$template->assign_vars(array(
			'S_INSTALL_KEY' => $HTTP_POST_VARS['install_key'],
			'S_INSTALL_KEY_ADMIN' => $HTTP_POST_VARS['install_key_admin'],
			'L_INSTALL_KEY_ERROR' => (empty($HTTP_POST_VARS['install_key'])) ? sprintf($lang['GMap_Install_key_error'], $board_config['server_name'] . $board_config['script_path']) : '',
			'L_INSTALL_KEY_ADMIN_ERROR' => (empty($HTTP_POST_VARS['install_key_admin'])) ? sprintf($lang['GMap_Install_key_error'], $board_config['server_name'] . $board_config['script_path'] . 'admin/') : '',
		));
	}
}


//
// Pull all config data
//
$sql = "SELECT *
	FROM " . CONFIG_TABLE . "
        WHERE config_name LIKE 'googlemap_%'";
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query config information", "", __LINE__, __FILE__, $sql);
} else {

	$new = array();
	$row = array();
	
	while( $row = $db->sql_fetchrow($result) )
	{
		$new[$row['config_name']] = ( isset($HTTP_POST_VARS[$row['config_name']]) ) ? $HTTP_POST_VARS[$row['config_name']] : $row['config_value'];

		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$row['config_name']]) . "'
				WHERE config_name = '" . $row['config_name'] . "'";
			
			if( !$db->sql_query($sql) )
			{
				$config_name = $row['config_name'];
				message_die(GENERAL_ERROR, "Failed to update general configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_googlemap_config'], "<a href=\"" . append_sid("admin_googlemap.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
	
	$template->assign_block_vars('switch_installed', array());
	
}

$template->set_filenames(array(
	'body' => 'admin/googlemap_config_body.tpl')
);

$template->assign_vars(array(
	'L_GOOGLEMAP_SETTINGS' => $lang['GMap_Settings'],
	'L_SECTION_BASIC' => $lang['GMap_Basic_Settings'],
	
	'L_CONFIGURATION_EXPLAIN' => $lang['GMap_Settings_explain'],
	'L_INSTALLATION_EXPLAIN' => $lang['GMap_Installation_explain'],
	'L_GOOGLE_API_KEY' => $lang['GMap_google_api_key'],
	'L_GOOGLE_API_KEY_EXPLAIN' => sprintf($lang['GMap_google_api_key_explain'], $board_config['server_name'] . $board_config['script_path']),
	'L_GOOGLE_API_KEY_EXPLAIN_INSTALL' => sprintf($lang['GMap_Install_google_api_key_explain'], $board_config['server_name'] . $board_config['script_path']),
	'L_GOOGLE_API_KEY_ADMIN' => $lang['GMap_google_api_key_admin'],
	'L_GOOGLE_API_KEY_ADMIN_EXPLAIN' => sprintf($lang['GMap_google_api_key_admin_explain'], $board_config['server_name'] . $board_config['script_path']),
	'L_GOOGLE_API_KEY_ADMIN_EXPLAIN_INSTALL' => sprintf($lang['GMap_Install_google_api_key_admin_explain'], $board_config['server_name'] . $board_config['script_path']),
	'L_GOOGLEMAP_SIZE' => $lang['GMap_size'],
	'L_SHOW_STATS' => $lang['GMap_show_stats'],
	'L_SHOW_STATS_EXPLAIN' => $lang['GMap_show_stats_explain'],
	'L_GOOGLEMAP_SIZE_EXPLAIN' => $lang['GMap_size_explain'],
	'L_GMAP_FINDCOORDS_EXPLAIN' => $lang['GMap_find_coordinates_admin_explain'],
	'L_GMAP_FIND_COORDINATES' => $lang['GMap_find_coordinates'],
	'U_GMAP_FIND_COORDINATES' => append_sid($phpbb_root_path . 'google_selectmap.' . $phpEx),
	'L_SUBMIT' => $lang['Submit'],
	'L_RESET' => $lang['Reset'],
	'L_ENABLED' => $lang['Enabled'],
	'L_DISABLED' => $lang['Disabled'],
	'L_INSTALL' => $lang['GMap_Installation'],
	'S_SHOW_STATS_YES' => ($new['googlemap_show_stats']) ? ' checked="checked" ' : '',
	'S_SHOW_STATS_NO' => (!$new['googlemap_show_stats']) ? ' checked="checked" ' : '',
	
	'S_GOOGLE_API_KEY_ADMIN' => $new['googlemap_google_api_key_admin'],
	'S_GOOGLE_API_KEY' => $new['googlemap_google_api_key'],
	'MAP_WIDTH' => $new['googlemap_width'],
	'MAP_HEIGHT' => $new['googlemap_height'],
	'START_LONG' => $new['googlemap_start_long'],
	'START_LAT' => $new['googlemap_start_lat'],
	'START_ZOOM' => $new['googlemap_start_zoom'],
	'START_MODE' => $new['googlemap_start_map_type'],
));


$start_long = $new['googlemap_start_long'];
$start_lat = $new['googlemap_start_lat'];
$start_zoom_level = $new['googlemap_start_zoom'];


include ($phpbb_root_path . "includes/functions_selectmap." . $phpEx);
make_googlemap_js (4, $start_long, $start_lat, $start_zoom_level, $limits, NULL);

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>
