<?php
/***************************************************************************
 *
 *   title:               Mapa Google
 *   file:                google_selectmap.php
 *   authors:             qbs
 *                        paszczak
 *   web:                 beatsfactory.pl/qbs/
 *                        paszczak.thecamels.org
 *
 *   --- Based on --------------------
 *
 *   MOD                  : Atlas MOD
 *   file                 : gmap.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_selectmap.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_googlemap.' . $phpEx);

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

if ($HTTP_GET_VARS['mode'] == 'xml')
{
	include($phpbb_root_path . 'includes/functions_selectmap_xml.php');
	die();
}

define('SHOW_ONLINE', true);
$page_title = $lang['GMap'];

$selecting_location = $gen_simple_header = true;
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

//
// extracting file containing city cords
//
$gmc_file = 'googlemap_cords.gmc';

$fp = 	@fopen( $gmc_file, 'r+' );
$ct = 	@fread( $fp, filesize( $gmc_file ) );
	@fclose( $fp );

$array = $gmc_db = array();
preg_match_all("#<gme>(.*?)</gme>#is",$ct, $array);
define('NL', "\r\n");

$gmap_js_code = 'var gmaplngs = new Array();' . NL;
$gmap_js_code .= 'var gmaplats = new Array();' . NL . NL;
$gmap_select_options = '';

$index = 0;
foreach( $array[0] as $value )
{
	$index++;
	$value = explode(',', $value);
	$value[0] = str_replace(array('<gme>', '</gme>'), '', $value[0]);
	$value[1] = str_replace(array('<gme>', '</gme>'), '', $value[1]);
	$value[2] = str_replace(array('<gme>', '</gme>'), '', $value[2]);
	
	$gmap_js_code .= 'gmaplngs[' . $index . '] = \'' . $value[2] . '\'' . NL;
	$gmap_js_code .= 'gmaplats[' . $index . '] = \'' . $value[1] . '\'' . NL . NL;
	$gmap_select_options .= ( !empty($value[0]) ) ? '<option value="' . $index . '">' . $value[0] . '</option>' : '';
}

//
//
//

$template->set_filenames(array(
    'body' => 'google_map_select.tpl')
);


if (!isset($board_config['googlemap_google_api_key']))
{
	message_die(GENERAL_ERROR, $lang['GMapError_not_finished_install']);
}
else
{
	$template->assign_block_vars('googlemap', array());
	$template->assign_block_vars('switch_installed', array());
	
	if ($userdata["session_logged_in"])
	{
		$l_map_title = $lang['GMap_find_coordinates'];
		$l_explain = $lang['GMap_find_coordinates_explain'];
		$modus = 3;
	} else {
		message_die(GENERAL_ERROR, $lang['GMapError_you_must_log_in']);
	}

	$start_long = $board_config['googlemap_start_long'];
	$start_lat = $board_config['googlemap_start_lat'];
	
	make_googlemap_js (3, $start_long, $start_lat, $start_zoom_level, $limits, $distance_parameters);
	
	$template->assign_vars(array(
		'MAP_HEIGHT' => intval($board_config['googlemap_height'] - 50) . 'px',
		'COPYRIGHTS' => $lang['Copyrights'],
		'GMAP_CORDS' => $gmap_js_code,
		'GMAP_SELECT_CORD' => $lang['GMap_select_cord_option'],
		'L_SELECT_CORDS' => $lang['GMap_select_cords_explain'],
		'GMAP_SC_OPTIONS' => $gmap_select_options
	));
}

//
// Generate the page
//
$template->pparse('body');
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>
