<?php
/***************************************************************************
 *
 *   title:               	Mapa Google
 *   file:                	functions_map.php
 *   authors:            qbs
 *                       	paszczak
 *   web:                 	beatsfactory.pl/qbs/
 *                        	paszczak.thecamels.org
 *
 *   --- Based on --------------------
 *
 *   MOD                  	: GMap Mod
 *   file                	: functions_map.php
 *   copyright           : (C) 2005 Lviathan
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

function getmapstats()
{
	global $mapstats;

	$admins_on = $mods_on = $adminmods_off = $users_on = $users_off = 0;
	foreach($mapstats as $key => $value)
	{
		if ( $key == 'green' ) 	$admins_on = $value;
		if ( $key == 'yellow' ) 	$mods_on = $value;
		if ( $key == 'red' ) 		$adminmods_off = $value;
		if ( $key == 'white' ) 	$users_on = $value;
		if ( $key == 'gray' ) 	$users_off = $value;
	}
	return array($admins_on, $mods_on, $adminmods_off, $users_on, $users_off);
}

function unpolish( $txt )
{
	$txt = str_replace( '', 'a', $txt );
	$txt = str_replace( '', 'A', $txt );
	$txt = str_replace( '', 'c', $txt );
	$txt = str_replace( '', 'C', $txt );
	$txt = str_replace( '', 'e', $txt );
	$txt = str_replace( '', 'E', $txt );
	$txt = str_replace( '', 'l', $txt );
	$txt = str_replace( '', 'L', $txt );
	$txt = str_replace( '', 'n', $txt );
	$txt = str_replace( '', 'N', $txt );
	$txt = str_replace( '', 'o', $txt );
	$txt = str_replace( '', 'O', $txt );
	$txt = str_replace( '', 's', $txt );
	$txt = str_replace( '', 'S', $txt );
	$txt = str_replace( '', 'z', $txt );
	$txt = str_replace( '', 'Z', $txt );
	$txt = str_replace( '', 'z', $txt );
	$txt = str_replace( '', 'Z', $txt );

	return $txt;
}

$file_xml = $phpbb_root_path . "markers.xml";

$id_file = @fopen($file_xml, "w+") or die('Can\'t find markers file.');

$file_text = "<markers>\n\n";

$sql_select = "";
$sql = "	SELECT 	user_long, user_lat, user_id, username, user_level, user_from, user_session_time
		FROM 	" . USERS_TABLE . "
		WHERE 	user_long <> '' and
			user_lat <> ''";

if( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Error occured while importing user data.", "", __LINE__, __FILE__, $sql);
}

$mapstats = $cords_db = array();

while ( $users_rows = $db->sql_fetchrow($result) )
{
	$time_exp = time() - $users_rows['user_session_time'];
	$type = ( $time_exp <= 300 && $users_rows['user_level'] == 1  ) ? 'green' : $type;
	$type = ( $time_exp <= 300 && $users_rows['user_level'] == 2  ) ? 'yellow' : $type;
	$type = ( $time_exp > 300 && $users_rows['user_level']  ) ? 'red' : $type;
	$type = ( $time_exp <= 300 && !$users_rows['user_level']  ) ? 'white' : $type;
	$type = ( $time_exp > 300 && !$users_rows['user_level']  ) ? 'gray' : $type;
	$mapstats[$type] = $mapstats[$type] + 1;
	$ulng = $users_rows['user_long'];
	$ulat = $users_rows['user_lat'];
	$users_rows['type'] = $type;
	unset($users_rows['user_lat'], $users_rows['user_long'], $users_rows['user_level']);

	if ( $cords_db[$ulng . 'x' . $ulat] )
	{
		$tmp = $cords_db[$ulng . 'x' . $ulat];

		if( $tmp['multi'] != 1 )
		{
			$tmp_title = $tmp['user_from'];
			$tmp_user_from = $tmp['username'] . ', ' . $users_rows['username'];
		} else {
			$tmp_title = $tmp['username'];
			$tmp_user_from = $tmp['user_from'] . ', ' . $users_rows['username'];
		}
		$tmp_array = array(
			'user_from' =>  $tmp_user_from,
			'username' =>  $tmp_title,
			'type' =>  'blue',
			'multi' =>  1
			);
			
		$cords_db[$ulng . 'x' . $ulat] = $tmp_array;
	} else {
		$users_rows['multi'] = 0;
		$cords_db[$ulng . 'x' . $ulat] = $users_rows;
	}
}

foreach ( $cords_db as $cords => $rest )
{
	$cords = explode('x', $cords);
	$addtext = ( $rest['multi'] == 1 ) ? 'kto' : 'gdzie';
	$file_text .= '<marker lng="' . $cords[0] . '" lat="' . $cords[1] . '" title="' . unpolish($rest['username']) . '" text="' . unpolish($rest['user_from']) . '" type="' . $rest['type'] . '" addtext="' . $addtext . '" />' . "\r\n";
}

$file_text .= "\n</markers>";


$verify = @fwrite($id_file,$file_text) or die('Can\'t write data to the markers file.');

$verify = @fclose($id_file);

?>
