<?php
/***************************************************************************
 *
 *   title:               Mapa Google
 *   file:                functions_selectmap.php
 *   authors:             qbs
 *                        paszczak
 *   web:                 beatsfactory.pl/qbs/
 *                        paszczak.thecamels.org
 *
 *   --- Based on --------------------
 *
 *   MOD                  : Atlas MOD
 *   file                 : includes/gmap_functions.php
 *   copyright            : (C) 2005 Jonas Neubert
 *   web                  : www.jonemo.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

function make_googlemap_js ($modus, $start_long, $start_lat, $start_zoom_level, $limits, $distance_parameters)
{
	global $template, $board_config, $lang, $phpbb_root_path, $nav_links, $gen_simple_header, $phpEx;
	global $userdata, $user_ip, $session_length;

	include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_googlemap.' . $phpEx);

	$template->set_filenames(array(
		'selectmapjs' => 'google_map_select_js.tpl')
	);

	$template->assign_vars(array(
		'U_XML_ADRESS' => append_sid($phpbb_root_path . 'google_selectmap.' . $phpEx . '?mode=xml'),
		'U_GOOGLEMAP_SELECT_JS' => $phpbb_root_path . 'includes/functions_selectmap.js',
		'LONGITUDE' => ($userdata['user_long']) ? $userdata['user_long'] : $board_config['googlemap_start_long'],
		'LATITUDE' => ($userdata['user_lat']) ? $userdata['user_lat'] : $board_config['googlemap_start_lat'],
		'MODUS' => $modus,
		'GOOGLE_API_KEY' => (defined('IN_ADMIN')) ? $board_config['googlemap_google_api_key_admin'] : $board_config['googlemap_google_api_key'],
		'START_MAP_TYPE' => $board_config['googlemap_start_map_type'],
		'START_LONG' => ($start_long) ? $start_long : $board_config['googlemap_start_long'],
		'START_LAT' => ($start_lat) ? $start_lat : $board_config['googlemap_start_lat'],
		'START_ZOOM_LEVEL' => ( empty($start_zoom_level) ) ? $board_config['googlemap_start_zoom'] : $start_zoom_level,
		'START_MIN_LONG' => $limits['min_long'],
		'START_MAX_LONG' => $limits['max_long'],
		'START_MIN_LAT' => $limits['min_lat'],
		'START_MAX_LAT' => $limits['max_lat'],

		'L_CHOOSE_THIS' => $lang['GMap_set_this_location'],
		'L_YOUR_LOCATION' => $lang['GMap_your_location'],
		'L_GMAP_NOT_COMPATIBLE' => $lang['GMap_not_compatible'],
		'L_CALLED_OFFLINE' => $lang['GMap_called_offline'],
		'L_LONGITUDE' => $lang['GMap_longitude'],
		'L_LATITUDE' => $lang['GMap_latitude'],
		'L_USERNAME' => $lang['Username'],
		'L_DISTANCE' => $lang['GMap_distance'],
	));

	$template->assign_var_from_handle('SELECTMAP_JS', 'selectmapjs');
}

?>
